misc = {}
const = {}

function misc.pixel_to_tile(pixel)
	return misc.round((pixel-16)/32)
end

function misc.tile_to_pixel(tile)
	return (tile*32)+16
end

function misc.point_direction(x1,y1,x2,y2)
	return -math.deg(math.atan2(x1-x2,y1-y2))
end

function misc.point_distance(x1,y1,x2,y2)
	return math.sqrt((x1-x2)^2 + (y1-y2)^2)
end

function misc.lengthdir_x(dir,length)
	return math.cos(math.rad(dir - 90))*length
end

function misc.lengthdir_y(dir,length)
	return math.sin(math.rad(dir - 90))*length
end

function misc.check(data1,data2) -- compares 2 variables, useful to save space
    if (type(data1) == "table") then
        local i = 0
        while (i < #data1) do
            i = i + 1
            if (type(data2) == "table") then
                local ii = 0
                while (ii < #data2) do
                    ii = ii + 1
                    if (data1[i] == data2[ii]) then
                        return true
                    end
                end
            else
                if (data1[i] == data2) then
                    return true
                end
            end
        end
        return false
    else
        if (type(data2) == "table") then
            local ii = 0
            while (ii < #data2) do
                ii = ii + 1
                if (data1[i] == data2[ii]) then
                    return true
                end
            end
        else
            if (data1 == data2) then
                return true
            end
        end
        return false
    end
end


function misc.split_text(text)
    --[[
	local command_input = {}
	for word in string.gmatch(text, "[!-z]+") do
		command_input[#command_input+1] = word
	end
	return command_input
    ]]--
	local command_input = {}
	for word in string.gmatch(text, "[!-z]+") do
        if (not(tonumber(word) == nil)) then
            word = tonumber(word)
        end
		command_input[#command_input+1] = word
	end
	return command_input
end

function misc.fileExists(file)
    local f = io.open(file,"r")
    if f == nil then
        return false
    else
        f:close()
        return true
    end
   --if f~=nil then io.close(f) return true else return false end
end
--	local file_check = io.open(file,"r")
--	if file_check == nil then
--		return false
--	end
--	file_check:close()
--	return true
--end
misc.timeTranslatorCharDefault = 1
misc.timeTranslatorChar = {
{c="s",t=1,s="Second"}, -- default
{c="m",t=60,s="Minute"},
{c="h",t=60*60,s="Hour"},
{c="d",t=60*60*24,s="Day"},
{c="w",t=60*60*24*7,s="Week"},
{c="M",t=60*60*24*30,s="Month"},
{c="y",t=60*60*24*365,s="Year"}}
function misc.timeTranslator(timeString)
    local totalTime = 0
    local latest_num = ""
	local i = 0
    while (i < string.len(timeString)) do
        i = i + 1
        c = string.sub(timeString,i,i)
        if tonumber(c) == nil then
            if latest_num == "" then -- FAIL: the time was empty
                misc.timeTranslator_error = i-1
                return false
            end
            local found_c = false
            local ii = 0
            while (ii < #misc.timeTranslatorChar) do
                ii = ii + 1
                if misc.timeTranslatorChar[ii].c == c then
                    found_c = true
                    local temp = tonumber(latest_num)
                    latest_num = ""
                    totalTime = totalTime + (temp*misc.timeTranslatorChar[ii].t)
                    break
                end
            end
            if not(found_c) then
                misc.timeTranslator_error = i
                return false
            end
        else
            latest_num = latest_num..c
        end
    end
    if not(latest_num == "") then --missing type? assuming seconds
        local temp = tonumber(latest_num)
        totalTime = totalTime + (temp*misc.timeTranslatorChar[misc.timeTranslatorCharDefault].t)
    end
    return totalTime
end

function misc.secondsToString(seconds)
    str = ""
    check_index = #misc.timeTranslatorChar
    while (check_index > 0) do
        local timeNum =  math.floor(seconds / misc.timeTranslatorChar[check_index].t)
        seconds = seconds - (timeNum*misc.timeTranslatorChar[check_index].t)
        -- [] --
        if (timeNum > 0) then
            type_name = misc.timeTranslatorChar[check_index].s
            if (timeNum > 1) then
                type_name = type_name.."'s"
            end
            str = timeNum.." "..type_name.." "..str
        end
        check_index = check_index - 1
    end
    return str
end

--addhook("say","misc.say") -- used in testing the !time command
function misc.say(id,text)
    command = misc.split_text(text)
    if command[1] == "!time" then
        result = misc.timeTranslator(command[2])
        if result == false then
            local err = misc.timeTranslator_error
            local err_pos = err
            if err == 0 then
                err_pos = 1
            end
            msg(misc.rgb(255,0,0).."Error at position "..err_pos)
            if err == 0 then
                msg(misc.rgb(255,0,0)..command[2])
            else
                msg(misc.rgb(0,255,0)..string.sub(command[2],1,err-1)..misc.rgb(255,0,0)..string.charAt(command[2],err)..misc.rgb(255,255,0)..string.sub(command[2],err+1))
            end
            pre = ""
            if err > 0 then
                pre = misc.rgb(0,255,0)..string.sub(command[2],1,err-1)--string.rep("_",err)
            end
            msg(pre..misc.rgb(255,0,0).."^")
            --return 1
        else
            msg("Data returned: "..result.." Seconds")
            msg("aka: "..misc.secondsToString(result))
        end
        --return 1
    end
end

function misc.isNearPlayers(x,y,dist,exception)
	local pl = player(0,"tableliving")
	for i=1,#pl do
		if player(pl[i],"x") < x+dist and player(pl[i],"x") > x-dist and player(pl[i],"y") < y+dist and player(pl[i],"y") > y-dist then
            if (type(exception) == "table") then
                hit = true
                ii = 0
                while (ii < #exception) do
                    ii = ii + 1
                    if (pl[i] == exception[ii]) then
                        hit = false
                    end
                end
                if (hit) then
                    return pl[i]
                end
            else
                return pl[i]
            end
		end
	end
	return 0
end

function misc.round(num,base)
	if base == nil then
		return math.floor(num+0.5)
	else
		return math.floor((num*base)+0.5)/base
	end
end

function misc.debugImage(x,y,r,g,b,t)
	local temp = image("gfx/hud_dot.bmp",x,y,3)
	if t == nil then
		t = 1000
	end
    if (t > 0) then
        timer(t,"freeimage",temp)
    end
	if (r == nil) == false then
		imagecolor(temp,r,g,b)
	end
end

-- THIS FUNCTION MIGHT NOT WORK YET
misc.hudTextIdAllocation = {}
misc.hudTextIdAllocationStart = 25
function misc.hudTextOnScreen(text,x,y,align,duration)
	pl = player(0,"tableliving")
	for i=1,#pl do
		if misc.hudTextIdAllocation[pl[i]] == nil then
			misc.hudTextIdAllocation[pl[i]] = 0
		end
		local px = x-player(pl[i],"x")+320
		local py = y-player(pl[i],"y")+240
		if (py > 0) and (px > 0) and (py < 640) and (py < 480) then
			misc.hudText(misc.hudTextIdAllocationStart+misc.hudTextIdAllocation[pl[i]],pl[i],text,px,py,align)
			misc.hudTextColor(misc.hudTextIdAllocationStart+misc.hudTextIdAllocation[pl[i]],pl[i],1,255,0,0)
			misc.hudTextFade(misc.hudTextIdAllocationStart+misc.hudTextIdAllocation[pl[i]],pl[i],duration,0)
			misc.hudTextIdAllocation[pl[i]] = misc.hudTextIdAllocation[pl[i]] + 1
			if misc.hudTextIdAllocation[pl[i]] >= (49-misc.hudTextIdAllocationStart) then
				misc.hudTextIdAllocation[pl[i]] = 0
			end
		end
	end
end

function misc.hudText(id,pid,text,x,y,align)
	parse("hudtxt2 "..pid.." "..id.." \""..text.."\" "..x.." "..y.." "..align.."")
	return id
end

function misc.hudTextFade(id,pid,duration,alpha)
	parse("hudtxtalphafade "..pid.." "..id.." "..duration.." "..alpha.."")
	return id
end

function misc.hudTextColor(id,pid,duration,r,g,b)
	parse("hudtxtcolorfade "..pid.." "..id.." "..duration.." "..r.." "..g.." "..b.."")
	return id
end

function misc.explosion(x,y,size,dmg,src)
	parse("explosion "..x.." "..y.." "..size.." "..dmg.." "..src)
end

function misc.effect(effect,x,y,amount,radius,r,g,b)
    parse("effect \""..effect.."\" "..x.." "..y.." "..amount.." "..radius.." "..r.." "..g.." "..b)
end

misc.armourValue = {{id=206,protection=0}, -- stealth armour
{id=205,protection=95}, -- super armour
{id=204,protection=0}, -- medic armour
{id=203,protection=75}, -- heavy armour
{id=202,protection=50}, -- medium armour
{id=201,protection=25}} -- light armour
function misc.calcDamage(id,dmg)
	local armor = player(id,"armor")
	for i=1,#misc.armourValue do
		if armor == misc.armourValue[i].id then
			return dmg - ((dmg / 100) * misc.armourValue[i].protection)
		end
	end
	return dmg
end

-- DISCLAIMER: NOT created by me, source: http://snippets.luacode.org/snippets/Shuffle_array_145
function misc.shuffle_array(ar)
    local n, order, res = #ar, {}, {}
     
    for i=1,n do order[i] = { rnd = math.random(), idx = i } end
    table.sort(order, function(a,b) return a.rnd < b.rnd end)
    for i=1,n do res[i] = ar[order[i].idx] end
    return res
end

function misc.colorTextPercent(percent)
	if percent > 100 then
		percent = 100
	end
	local r = misc.round(255-(percent*2.55))
	local g = misc.round(percent*2.55)
	local b = 0
    local yellowBoost = (50-(math.abs(percent-50)))
    if yellowBoost > 0 then
        yellowBoost = yellowBoost*2.55
    end
    r = r + yellowBoost
    g = g + yellowBoost
    r = math.floor(r)
    g = math.floor(g)
    b = math.floor(b)
	return (""..misc.minimum_3(r)..misc.minimum_3(g)..misc.minimum_3(b))
end

function misc.rgb(r,g,b)
	return (""..misc.minimum_3(r)..misc.minimum_3(g)..misc.minimum_3(b))
end

-- PRIVATE function
function misc.minimum_3(text)-- you arent really intended to use this function
	text = tostring(text)
	while (string.len(text) < 3) do
		text = "0"..text
	end
	return text
end

function misc.eval(code)
	file = io.open("sys/lua/eval.lua","w")
	if type(code) == "string" then
		file:write(code)
	end
	if type(code) == "table" then
		i = 0
		while (i < #code) do
			i = i + 1
			file:write(code[i])
		end
	end
	file:close()
	ret = dofile("sys/lua/eval.lua")
	os.remove("sys/lua/eval.lua")
	return ret
end

-- sense CS2D reads servertransfer BEFORE lua, you might need to restart, after your lua used this function

--if you want this function, then BE IN MIND that the current content in servertransfer.lst will be erased!

misc.doAddServerTransfer = true

if misc.doAddServerTransfer then
    file = io.open("sys/servertransfer.lst","w")
    file:write("")
    file:close()
end

function misc.addServerTransfer(image)
    if misc.doAddServerTransfer then
        print("added "..image.." to serverTransfer.lst")
        file = io.open("sys/servertransfer.lst","a")
        file:write(image.."\n")
        file:close()
    end
end

-- originally created by: http://gmc.yoyogames.com/index.php?showtopic=433253
-- converted to lua and modified by Endercrypt
function misc.turnTowards(direction, wdir, turnspeed)
    angdiff = ((((direction - wdir) % 360) + 540) % 360) - 180;
    return (direction - math.min(math.max(angdiff,-turnspeed),turnspeed)) % 360
end

function misc.maxmin(num,maxmin)
    return math.min(math.max(num,-maxmin),maxmin)
end

function misc.primitive_point_distance(x1,y1,x2,y2)
    return math.max(math.abs(x1-x2),math.abs(y1-y2))
end

------------------------
--[ STRING EXTENSION ]--
------------------------

function string.charAt(str,num)
    return string.sub(str,num,num)
end